src/web_app/dac/urls.py
from django.urls import path

from . import views

urlpatterns = [
    path("", views.home, name="dac-home"),
    path("about/", views.about, name="dac-about"),
    path("index/", views.index, name="index"),
    path("search/", views.SearchTlk.as_view(), name="search"),
    path("test-search/", views.SearchView.as_view(), name="test-search"),
]

src/web_app/web_app/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [path("", include("dac.urls")), path("admin/", admin.site.urls)]

src/web_app/dac/models.py
from django.db import models


class Question(models.Model):
    question_text = models.CharField(max_length=200)
    pub_date = models.DateTimeField("date published")

    def __str__(self):
        return self.question_text


class Choice(models.Model):
    question = models.ForeignKey(Question, on_delete=models.CASCADE)
    choice_text = models.CharField(max_length=200)
    votes = models.IntegerField(default=0)

    def __str__(self):
        return self.choice_text


# Create your models here.
class Search(models.Model):
    # I think it would be cool to track what people lookup hehe
    search_key = models.CharField(max_length=100)
    # idk how to do this, but link it to which game they are looking up
    game_key = models.CharField(max_length=30)  # dai, da2, dao, all
    resource_key = models.CharField(max_length=10)  # character, codex, or both
    date_searched = models.DateTimeField(
        auto_now_add=True
    )  # I want to know when it was searched by the user


class SearchTlk(models.Model):
    search_key = models.CharField(max_length=100)
    game_key = models.CharField(max_length=30)
    date_searched = models.DateTimeField(auto_now_add=True)


class SearchManager(models.Manager):
    def search(self, query=None):
        qs = self.get_queryset()
        if query is not None:
            qs = qs.filter(text__icontains=query)
        return qs


"""
Tlk
"""


class Tlk(models.Model):
    str_id = models.IntegerField()
    text = models.CharField(
        max_length=3000
    )  # might need to up this or use a textfield

    objects = SearchManager()

    class Meta:
        abstract = True

    def __str__(self):
        return self.text


class DAO_TLK(Tlk):
    pass


class DA2_TLK(Tlk):
    pass


class DAI_TLK(Tlk):
    text = models.TextField()


"""
Conversations
"""


class Conversations(models.Model):
    pass


class DAO_Conv(Conversations):
    pass


class DA2_Conv(Conversations):
    pass


class DAI_Conv(Conversations):
    pass


"""
Codex
"""


class Codex(models.Model):
    pass


class DAO_Codex(Codex):
    pass


class DA2_Codex(Codex):
    pass


class DAI_Codex(Codex):
    pass

src/web_app/dac/views.py
from .models import DAO_TLK, DA2_TLK, DAI_TLK

from django.shortcuts import render
from django.views.generic import ListView, TemplateView

from itertools import chain

fake_examples = [
    {
        "name": "Flemeth",
        "game": "Dragon Age: Origins",
        "content": "Why dance when you can sing?",
        "date": "fake_date",
    },
    {
        "name": "Hawke",
        "game": "Dragon Age 2",
        "content": "I want to be a dragon",
        "date": "fake_date2",
    },
]


def home(request):
    context = {"quotes": fake_examples}
    # handles traffic from homepage
    return render(request, "dac/home.html", context)


def about(request):
    return render(request, "dac/about.html", {"title": "About"})


class SearchTlk(TemplateView):
    template_name = "dac/search.html"


class SearchView(ListView):
    template_name = "dac/test.html"
    count = 0

    def get_context_data(self, *args, **kwargs):
        context = super().get_context_data(*args, **kwargs)
        context["count"] = self.count or 0
        context["query"] = self.request.GET.get("q")
        return context

    def get_queryset(self):
        request = self.request
        query = request.GET.get("q", None)

        if query is not None:
            dao_results = DAO_TLK.objects.search(query)
            da2_results = DA2_TLK.objects.search(query)
            dai_results = DAI_TLK.objects.search(query)

            queryset_chain = chain(dao_results, da2_results, dai_results)

            qs = list(queryset_chain)
            self.count = len(qs)
            return qs
        return DAO_TLK.objects.none()


class SearchResults(ListView):

    template_name = "dac/search_results.html"

    def get_queryset(self):  # use Q if more complicated
        model = {
            "dao": DAO_TLK.objects.all(),
            "da2": DA2_TLK.objects.all(),
            "dai": DAI_TLK.objects.all(),
        }
        query = self.request.GET.getlist("q")
        game = self.request.GET.getlist("game")[-1]
        object_list = model[game].objects.filter(text__icontains=query)
        return object_list


def index(request):
    # could do something like top searches...
    # latest_question_list = Question.objects.order_by("-pub_date")[:5]
    # context = {"latest_question_list": latest_question_list}
    return render(request, "dac/index.html", {})


# Create your views here.

src/web_app/dac/templates/dac/about.html
<!DOCTYPE html>
{% extends "dac/base.html" %}
{% block content %}
    <h2>About</h2>
    <p>The Dragon Age Compendium is a searchable collection of text resources from the Dragon Age games. As of v0.0.0 the Compendium includes dialogue and codex entries from the three main Dragon Age games, <em>not including</em> DLCs. There are several ways to use the Compendium: </p>

    <p>
        A configurable search function
    </p>
    <p>
        A conversation viewer
    </p>
    <p>
        A collection of developer notes and audio files of interest
    </p>
    <p></p>

    <p>Hard copies of the text can be found <a href="https://github.com/pod7/dragonage_compendium" target="_blank"> on GitHub</a>.</p>

    <h3>Contact</h3>
    <p>
        <a href="planesofduality@gmail.com" target="_blank"> email
        </a> |
        <a href="http://planesofduality.tumblr.com/" target="_blank"> tumblr
        </a> |
        <a href="https://twitter.com/planesofduality" target="_blank"> twitter
        </a>
    </p>
{% endblock content %}

src/web_app/dac/templates/dac/base.html
{% load static %}
<html lang="en">
<head>

    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">

    <link rel="stylesheet" type="text/css" href="{% static 'dac/main.css' %}">

    <meta charset="UTF-8">
    {% if title %}
        <title>The Dragon Age Compendium - {{ title }}</title>
    {% else %}
        <title>The Dragon Age Compendium</title>
    {% endif %}
</head>
<body>
    <header class="site-header">
      <nav class="navbar navbar-expand-md navbar-dark bg-steel fixed-top">
        <div class="container">
          <a class="navbar-brand mr-4" href="/">The Dragon Age Compendium</a>
          <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarToggle" aria-controls="navbarToggle" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarToggle">
            <div class="navbar-nav mr-auto">
              <a class="nav-item nav-link" href="/">Home</a>
              <a class="nav-item nav-link" href="/about">About</a>
            </div>
            <!-- Navbar Right Side -->
            <div class="navbar-nav">
              <a class="nav-item nav-link" href="#">Login</a>
              <a class="nav-item nav-link" href="#">Register</a>
            </div>
          </div>
        </div>
      </nav>
    </header>
    <main role="main" class="container">
      <div class="row">
        <div class="col-md-8">
          {% block content %}{% endblock %}
        </div>
        <div class="col-md-4">
          <div class="content-section">
            <h3>Sidebar</h3>
            <p class='text-muted'>Description goes here.
              <ul class="list-group">
                <li class="list-group-item list-group-item-light">Search</li>
                <li class="list-group-item list-group-item-light">Downloads</li>
                <li class="list-group-item list-group-item-light">Developer notes</li>
                <li class="list-group-item list-group-item-light">etc</li>
              </ul>
            </p>
          </div>
        </div>
      </div>
    </main>

    <script src="https://code.jquery.com/jquery-3.3.1.slim.min.js" integrity="sha384-q8i/X+965DzO0rT7abK41JStQIAqVgRVzpbzo5smXKp4YfRvH+8abtTE1Pi6jizo" crossorigin="anonymous"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.14.7/umd/popper.min.js" integrity="sha384-UO2eT0CpHqdSJQ6hJty5KVphtPhzWj9WO1clHTMGa3JDZwrnQq4sF86dIHNDz0W1" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js" integrity="sha384-JjSmVgyd0p3pXB1rRibZUAYoIIy6OrQ6VrjIEaFf/nJGzIxFDsf4x0xIM+B07jRM" crossorigin="anonymous"></script>
</body>
</html>

src/web_app/dac/templates/dac/detail.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
    <h1>{{ question.question_text }}</h1>
    <ul>
    {% for choice in question.choice_set.all %}
        <li>{{ choice.choice_text }}</li>
    {% endfor %}
    </ul>
</body>
</html>

src/web_app/dac/templates/dac/home.html
<!DOCTYPE html>
{% extends "dac/base.html" %}
{% block content %}
    Welcome to the Dragon Age Compendium!
    {% for post in quotes %}
        <h1>{{ post.content }}</h1>
        <p>-- {{ post.name }}, {{ post.game }}, {{ post.date }}</p>
    {% endfor %}
{% endblock content %}

src/web_app/dac/templates/dac/index.html
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title test</title>
</head>
<body>
{% if latest_question_list %}
    <ul>
    {% for question in latest_question_list %}
        <li><a href="/polls/{{ question.id }}/">{{ question.question_text }}</a></li>
    {% endfor %}
    </ul>
{% else %}
    <p>No polls are available.</p>
{% endif %}
</body>
</html>

src/web_app/dac/templates/dac/search.html
<h1>Search</h1>

<form action="{% url 'search_results' %}" method="get">
    <label>
        <input name="game" type="text" placeholder="all">
    </label>
    <label>
        <input name="q" type="text" placeholder="Search...">
    </label>
</form>

src/web_app/dac/templates/dac/search_results.html
<h1>Search Results</h1>

<ul>
  {% for line in object_list %}
    <li>
      {{ line.text }}
    </li>
  {% endfor %}
</ul>

src/web_app/dac/templates/dac/test.html
{% extends "dac/base.html" %}
{% load class_name %}
{% load highlight_query %}
{% block content %}

<h1>TLK Search</h1>

<p>
A basic search of the raw Dragon Age talk tables, with no relational information;
    this means the results may include lines that were cut or developer notes that were not removed before the
    game shipped. To search for a certain character's lines, or to limit search to dialogue or codex entries,
    use the advanced search function.
</p>

<div class='row title-row my-5'>

    <div class='col-12 py-0'>
        <h3 class='my-0 py-0'>{{ count }} results for <b>{{ query }}</b></h3>
    </div>
</div>

{% for object in object_list %}
    {% with object|class_name as klass %}
      {% if klass == 'DAO_TLK' %}
           <div class='row'>
             <div class='col-12'>
                DAO: <a href='{{ object.get_absolute_url }}'>{{ object.text|highlight_query:query }}</a>
            </div>
          </div>

      {% elif klass == 'DA2_TLK' %}
           <div class='row'>
             <div class='col-12'>
                DA2: <a href='{{ object.get_absolute_url }}'>{{ object.text|highlight_query:query }}</a>
              </div>
            </div>

      {% elif klass == 'DAI_TLK' %}
           <div class='row'>
                <div class='col-12'>
                   DAI: <a href='{{ object.get_absolute_url }}'>{{ object.text|highlight_query:query }}</a>
                </div>
            </div>
      {% else %}
           <div class='row'>
             <div class='col-12 col-lg-8 offset-lg-4'>
                <a href='{{ object.get_absolute_url }}'>{{ object }} | {{ object|class_name }}</a>
            </div>
           </div>
        {% endif %}
        
    {% endwith %}
    
{% empty %}
<div class='row'>
    <div class='col-12 col-md-6 mx-auto my-5 py-5'>
    <form method='GET' class='' action='.'>
    
        <div class="input-group form-group-no-border mx-auto" style="margin-bottom: 0px; font-size: 32px;">
            <span class="input-group-addon cfe-nav" style='color:#000'>
                <i class="fa fa-search" aria-hidden="true"></i>
            </span>
            <input type="text" name="q" data-toggle="popover" data-placement="bottom" data-content="Press enter to search" class="form-control cfe-nav mt-0 py-3" placeholder="Search..." value="" style="" data-original-title="" title="" autofocus="autofocus">
        </div>

    </form>

    </div>
</div>
{% endfor %}
{% endblock content %}